import datetime as dt
import random as rd
import math

NRLEVELS = 5

def base_salary(mydate):
    return 20000 + (mydate.year-1970)*2000

def next_weekday(mydate):
    if mydate.strftime("%A") == 'Saturday':
        return mydate+dt.timedelta(days=2)
    elif mydate.strftime("%A") == 'Sunday':
        return mydate+dt.timedelta(days=1)
    return mydate

##now = dt.date(2023, 1, 20)
##for _ in range(20):   
##    print(now.isoformat(), now.strftime("%a"), next_weekday(now).isoformat())
##    now = now + dt.timedelta(days=1)
##
class Gl:
    beginning_date = dt.date(1990, 3, 1)

def make_career(hire_date):
    level = rd.randint(1,2)
    salary = int(base_salary(hire_date)+level*5000+round(rd.random(),2)*10000)
    lista = [(hire_date, salary, level)]
    eval_date = next_weekday(hire_date + dt.timedelta(days=400))
    while True:
        if eval_date > dt.date(2023,1,1):
            break
        if rd.random()<0.1:
            if level <= NRLEVELS-1:
                level +=1
            salary +=3000
        elif rd.random()<0.3:
            offset = rd.randint(-150, 150)
            last_day = next_weekday(eval_date) + dt.timedelta(days=offset)
            lista.append( (last_day, 0, 0) )
            break
        determinant = rd.random()
        if determinant < 0.1:
            salary *= .99
        elif determinant < 0.3:
            salary *= 1.01
        elif determinant < 0.5:
            salary *= 1.05
        else:
            salary *= 1.02
        salary = int(math.ceil(salary/100.0))*100
        lista.append((eval_date, salary, level))
        eval_date = next_weekday(eval_date + dt.timedelta(days=366))
##    for item in lista:
##        print(item[0].isoformat(), item[1], item[2])
    
    return lista

##timedelta = (dt.date(2023, 1, 1) - Gl.beginning_date).days
##offset = rd.randint(0,timedelta)
##hire_date = next_weekday(Gl.beginning_date+dt.timedelta(days=offset))

