from __future__ import print_function
from datetime import date, datetime, timedelta
import mysql.connector
from curriculum import *
from person import birthday
from namecreator import get_name

import random as rd
rd.seed(15121955)

Gl.beginning_date = date(1990,9,1)

myhost = 'localhost'
myuser = 'root'
mypassword = '1EmilLie'

mydb = mysql.connector.connect(
    host = myhost,
    user = myuser,
    password = mypassword
    )

mycursor = mydb.cursor()
try:
    mycursor.execute("DROP DATABASE myEmployee")
except:
    pass

try:
    mycursor.execute("CREATE DATABASE IF NOT EXISTS myEmployee")
except:
    print('could not create database')

##try:
##    mycursor.execute("SHOW DATABASES")
##    for item in mycursor:
##        print(item)
##except:
##   print('Could not show database') 

mydb = mysql.connector.connect(
    host = 'localhost',
    user = 'root',
    password = '1EmilLie',
    database = 'myEmployee'
    )
mycursor = mydb.cursor()

sql1 = """
DROP TABLE IF EXISTS salaries, 
                     employees;
"""
mycursor.execute(sql1)

sql2 = """
CREATE TABLE employees (
    emp_no      INT             NOT NULL,
    birth_date  DATE            NOT NULL,
    first_name  VARCHAR(14)     NOT NULL,
    last_name   VARCHAR(16)     NOT NULL,
    gender      ENUM ('M','F')  NOT NULL,
    citizenship VARCHAR(16)     NOT NULL,
    hire_day   DATE             NOT NULL,
    last_day    DATE            DEFAULT "9999-12-31",
    PRIMARY KEY (emp_no)
);
"""
mycursor.execute(sql2)


sql3 = """
CREATE TABLE salaries (
    emp_no        INT          NOT NULL,
    start_day    DATE          NOT NULL,
    end_day      DATE          NOT NULL,
    elevel         INT          NOT NULL,
    salary        INT          NOT NULL,
    PRIMARY KEY (emp_no, start_day)
);
"""
mycursor.execute(sql3)

mydb.commit()

empi_no = 100000

def create_employee(hire_date):
    global empi_no
    empi_no += 1
    hire_date = next_weekday(hire_date)
    lista = make_career(hire_date)
    last_day, salary, level = lista[-1]
    if not level == 0:
        last_day = date(9999,12,31)
    first, last, gender, country = get_name() 
    birth_date = birthday(hire_date)
    sqli = f"""INSERT INTO employees
    (emp_no, birth_date, first_name, last_name, gender, citizenship, hire_day, last_day)
    VALUES (
        {empi_no},
        "{birth_date.isoformat()}",
        "{first}",
        "{last}",
        "{gender}",
        "{country}",
        "{hire_date.isoformat()}",
        "{last_day.isoformat()}"
    );
    """
    mycursor.execute(sqli)

    for i in range(len(lista)):
        first_day, salary, level = lista[i]
        if i < len(lista)-1:
            last_day = lista[i+1][0]
        else:
            if lista[i][2] == 0:
                break
            else:
                last_day = date(9999,12,31)      
        sqli = f"""INSERT into salaries 
        (emp_no, start_day, end_day, elevel, salary)
    VALUES (
        {empi_no},
        "{first_day.isoformat()}",
        "{last_day.isoformat()}",
        {level},
        {salary}
        );
    """
        mycursor.execute(sqli)
    mydb.commit()

for _ in range(150):
    hire_date = Gl.beginning_date
    create_employee(hire_date)
while hire_date < date(2023,1,1):
    hire_date = next_weekday(hire_date + timedelta(days=rd.randint(0,7)))
    create_employee(hire_date)
        
    






